package de.twenty11.skysail.common.restlet;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.restlet.Application;
import org.restlet.security.Role;

public class ApplicationDescriptor implements Serializable {

	private String author;
	private String name;
	private String description;
	private String owner;
	private ArrayList<RoleDescription> roles;

	public class RoleDescription {

		private String name;
		private String description;

		public RoleDescription(Role role) {
			name = role.getName();
			description = role.getDescription();
		}
		
		public String getName() {
			return name;
		}
		
		public String getDescription() {
			return description;
		}
	}

	public ApplicationDescriptor(Application application) {
		this.author = application.getAuthor();
		this.name = application.getName();
		this.description = application.getDescription();
		owner = application.getOwner();
		setRoles(application.getRoles());
	}
	
	public String getAuthor() {
		return author;
	}
	
	public String getName() {
		return name;
	}
	
	public String getDescription() {
		return description;
	}
	
	public String getOwner() {
		return owner;
	}
	
	public ArrayList<RoleDescription> getRoles() {
		return roles;
	}

	private void setRoles(List<Role> restletRoles) {
		this.roles = new ArrayList<RoleDescription>(); 
		for (Role role : restletRoles) {
			RoleDescription description = new RoleDescription(role);
			this.roles.add(description);
		}
	}

}
